
from z3 import *

communicationCost = Real('communicationCost')
computationCost = Real('computationCost')
nTask = 11
nNodes = 5
nUsers = 1
nConstraints = 2

tasks = [ [ Real("x_%s_%s" % (0, 0)) for c in range(3) ] 
      for r in range(nTask*nUsers) ]

nodes = [ [ Real("x_%s_%s" % (0, 0)) for c in range(5) ] 
      for r in range(nNodes+nUsers-1) ]

#{tarea, nodo}
assignement = [ [ Bool("ASING_%s_%s" % (r,c)) for c in range(nNodes+nUsers-1) ] 
      for r in range(nTask*nUsers) ]

#{nodo, usuario}
RAMresources = [ [ Real("RAM_%s_%s" % (r,c)) for c in range(nUsers+nUsers-1) ] 
for r in range(nNodes) ]

constraints = [ [ Real("cons_%s" % (0)) for c in range(9) ] 
      for r in range(nConstraints) ]


#Matriz de task x task. relation[1][0] cantidad de información a enviar de la tarea 1 a la 0 
relation = [ [ 0 for c in range(nTask) ] 
      for r in range(nTask) ]

relation[1][2] = 30 * 8
relation[2][3] = 350000 * 8
relation[3][4] = 340000 * 8
relation[4][5] = 330000 * 8
relation[5][6] = 25000 * 8
relation[3][7] = 340000 * 8
relation[7][8] = 200000 * 8
relation[7][9] = 200000 * 8
relation[9][10] = 15000 * 8

#{CPU, RAM, user}
aux = 0
for x in range(0, nUsers):
	tasks[aux][0] = 300000 #CameraCalibration
	tasks[aux][1] = 10
	tasks[aux][2] = x
	tasks[aux+1][0] = 200 #RequestFrame
	tasks[aux+1][1] = 10
	tasks[aux+1][2] = x
	tasks[aux+2][0] = 4000 #CaptureFrame
	tasks[aux+2][1] = 15
	tasks[aux+2][2] = x
	tasks[aux+3][0] = 6000000 #getFeatures
	tasks[aux+3][1] = 45
	tasks[aux+3][2] = x
	tasks[aux+4][0] = 400000 #poseEstimation
	tasks[aux+4][1] = 50
	tasks[aux+4][2] = x
	tasks[aux+5][0] = 400000 #consultObject
	tasks[aux+5][1] = 75
	tasks[aux+5][2] = x
	tasks[aux+6][0] = 40000 #overlayContent
	tasks[aux+6][1] = 100
	tasks[aux+6][2] = x
	tasks[aux+7][0] = 60000000 #updateMap
	tasks[aux+7][1] = 200
	tasks[aux+7][2] = x
	tasks[aux+8][0] = 400000 #updateTracker
	tasks[aux+8][1] = 120
	tasks[aux+8][2] = x
	tasks[aux+9][0] = 700000000 #lookForObjects
	tasks[aux+9][1] = 320
	tasks[aux+9][2] = x
	tasks[aux+10][0] = 200000 #lookForObjects
	tasks[aux+10][1] = 150
	tasks[aux+10][2] = x
	aux = aux + nTask



#[0] tiempo maximo en ser completado
#[1] numero de tareas implicadas en la restricción
#[2...n] indice de las tareas que son implicadas
constraints[0][0] = 0.034
constraints[0][1] = 7
constraints[0][2] = 0
constraints[0][3] = 1
constraints[0][4] = 2
constraints[0][5] = 3
constraints[0][6] = 4
constraints[0][7] = 5
constraints[0][8] = 6
constraints[1][0] = 0.51
constraints[1][1] = 3
constraints[1][2] = 3
constraints[1][3] = 4
constraints[1][4] = 5
#print(assignement)


#El Bandwidth calculado con la ley de Shannon's
#{CPU, Bandwidth. Coste Upload, k, RAM}
for x in range(0, nUsers):
	nodes[x][0] = 3000000
	nodes[x][1] = 3000000
	nodes[x][2] = 1800
	nodes[x][3] = 0.0000000001 
	nodes[x][4] = 4000.0


nodes[nUsers][0] = 30000
nodes[nUsers][1] = 13000000
nodes[nUsers][2] = 1700
nodes[nUsers][3] = 0.0000000001
nodes[nUsers][4] = 4000
nodes[nUsers + 1][0] = 8000000
nodes[nUsers + 1][1] = 8000000
nodes[nUsers + 1][2] = 1600
nodes[nUsers + 1][3] = 0.000000009
nodes[nUsers + 1][4] = 32000
nodes[nUsers + 2][0] = 30000
nodes[nUsers + 2][1] = 17000000
nodes[nUsers + 2][2] = 1800
nodes[nUsers + 2][3] = 0.0000000001
nodes[nUsers + 2][4] = 2000
nodes[nUsers + 3][0] = 20000
nodes[nUsers + 3][1] = 18000000
nodes[nUsers + 3][2] = 1300
nodes[nUsers + 3][3] = 0.00000000008
nodes[nUsers + 3][4] = 8000.0



opt = Optimize()

opt.add([Sum([If(assignement [t][m] ,1,0) for m in range(nNodes)]) == 1 for t in range(nTask*nUsers)])
opt.add([Sum([If(RAMresources [m][u] >= 0,1,0) for u in range(nUsers)]) == nUsers for m in range(nNodes)])
opt.add([Sum([RAMresources [m][u] for u in range(nUsers)]) <= nodes[m][4] for m in range(nNodes)])


opt.add(Sum([If(assignement [0 + nTask*u][u],1,0)* If(assignement [2 + nTask*u][u],1,0) * If(assignement [6 + nTask*u][u],1,0)  for u in range(nUsers)]) == nUsers)

#A CADA TAREA SE LE ASIGNA LA RAM QUE NECESITA
opt.add([Sum([If(assignement[t][m]*RAMresources[m][tasks[t][2]] >= assignement[t][m]*tasks[t][1],1,0) for t in range(nTask*nUsers)]) == nTask*nUsers for m in range(nNodes)])
#Una por restricción:
opt.add([Sum([If(Sum([Sum([simplify(assignement[constraints[0][i]+(u*nTask)][m]*(If(assignement[constraints[0][j]+(u*nTask)][m],0,1)*(relation[constraints[0][i]][constraints[0][j]]/nodes[m][1]))) for j in range(2, 2 + constraints[0][1])]) + assignement[constraints[0][i]+(u*nTask)][m]*tasks[constraints[0][i]+(u*nTask)][0]/nodes[m][0] for i in range(2, 2 + constraints[0][1])]) <= constraints[0][0],1,0) for m in range(nNodes)]) == nNodes for u in range(nUsers)])
opt.add([Sum([If(Sum([Sum([simplify(assignement[constraints[1][i]+(u*nTask)][m]*(If(assignement[constraints[1][j]+(u*nTask)][m],0,1)*(relation[constraints[1][i]][constraints[1][j]]/nodes[m][1]))) for j in range(2, 2 + constraints[1][1])]) + assignement[constraints[1][i]+(u*nTask)][m]*tasks[constraints[1][i]+(u*nTask)][0]/nodes[m][0] for i in range(2, 2 + constraints[1][1])]) <= constraints[1][0],1,0) for m in range(nNodes)]) == nNodes for u in range(nUsers)])

opt.add(communicationCost == Sum([Sum([Sum([Sum([simplify(assignement[i + u*nTask][m]*If(assignement[j+ u*nTask][m],0,1)*(nodes[m][2]*(relation[i][j]/nodes[m][1]))) for j in range(nTask)]) for i in range(nTask)]) for u in range(nUsers)]) for m in range(nNodes)]) )
opt.add(computationCost == Sum([Sum([simplify(assignement[i][m] * nodes[m][3] * tasks[i][0] * (nodes[m][0]**2)) for i in range(3*nUsers)]) for m in range(nNodes)]))
opt.minimize(communicationCost + communicationCost)


print(opt.check())
m = opt.model()
print(m)
print('Coste compputacional:')
print(m[computationCost].numerator_as_long()/m[computationCost].denominator_as_long())